EVP_PKEY_NEW(3)

NAME
EVP_PKEY_new, EVP_PKEY_up_ref, EVP_PKEY_free - private key allocation functions

SYNOPSIS
 #include <openssl/evp.h>

 EVP_PKEY *EVP_PKEY_new(void);
 int EVP_PKEY_up_ref(EVP_PKEY *key);
 void EVP_PKEY_free(EVP_PKEY *key);

DESCRIPTION
The EVP_PKEY_new() function allocates an empty EVP_PKEY structure which is used by OpenSSL to store private keys. The reference count is set to 1.

EVP_PKEY_up_ref() increments the reference count of key.

EVP_PKEY_free() decrements the reference count of key and, if the reference count is zero, frees it up. If key is NULL, nothing is done.

NOTES
The EVP_PKEY structure is used by various OpenSSL functions which require a general private key without reference to any particular algorithm.

The structure returned by EVP_PKEY_new() is empty. To add a private key to this empty structure the functions described in EVP_PKEY_set1_RSA(3) should be used.

RETURN VALUES
EVP_PKEY_new() returns either the newly allocated EVP_PKEY structure or NULL if an error occurred.

EVP_PKEY_up_ref() returns 1 for success and 0 for failure.

SEE ALSO
EVP_PKEY_set1_RSA(3)

HISTORY
EVP_PKEY_new() and EVP_PKEY_free() exist in all versions of OpenSSL.

EVP_PKEY_up_ref() was first added to OpenSSL 1.1.0.

COPYRIGHT
Copyright 2002-2016 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.